#!/usr/bin/python3

import json, os, shutil

#default_settings_dir = "/var/cache/astra-syslog"
default_settings_dir = "/usr/share/syslog-ng-mod-astra/event-settings"
user_settings_file = "/etc/astra-syslog.conf"
syslog_ng_settings_dir = "/etc/syslog-ng/conf.d"

def add_events_to_default_configuration():
    try:
        shutil.rmtree("{}/libvirtd".format(default_settings_dir), ignore_errors=True)
    except Exception as e:
        print(e)
        return False
    try:
        shutil.copytree("libvirtd", "{}/libvirtd".format(default_settings_dir))
    except Exception as e:
        print(e)
        return False
    return True

def add_events_to_user_configuration():
    try:
        with open(user_settings_file, "r+") as file:
            try:
                user_settings = json.load(file)
            except Exception as e:
                print(e)
                return False
            else:
                #role model
                user_settings.update({ "libvirtd-polkit-changed": { "enabled": "1" } })                    
                user_settings.update({ "libvirtd-polkit-removed": { "enabled": "1" } })
                user_settings.update({ "libvirtd-polkit-access-denied-by-parsec-role-model": { "enabled": "1" } })
                user_settings.update({ "libvirtd-polkit-access-parsec-role-model-switch-off": { "enabled": "1" } })
                user_settings.update({ "libvirtd-polkit-access-parsec-role-model-switch-on": { "enabled": "1" } })
                user_settings.update({ "libvirtd-polkit-changed-parsec-rules": { "enabled": "1" } })
                #config
                user_settings.update({ "libvirtd-config-changed-access-drivers": { "enabled": "1" } })                    
                user_settings.update({ "libvirtd-config-changed": { "enabled": "1" } })
                user_settings.update({ "libvirtd-attach-device-config": { "enabled": "1" } })
                user_settings.update({ "libvirtd-attach-device-live": { "enabled": "1" } })
                user_settings.update({ "libvirtd-change-disk-live": { "enabled": "1" } })
                user_settings.update({ "libvirtd-create-snapshot": { "enabled": "1" } })
                user_settings.update({ "libvirtd-detach-device-config": { "enabled": "1" } })
                user_settings.update({ "libvirtd-detach-device-live": { "enabled": "1" } })
                #backup
                user_settings.update({ "libvirtd-domain-backup-begin": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-backup-end": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-backup-cancel": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-dump-XML": { "enabled": "1" } })

                user_settings.update({ "libvirtd-domain-block-copy": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-block-resize": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-checkpoint-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-checkpoint-load": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-connect": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-core-dump": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-create-shapshot": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-create-XML": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-delete-checkpoint": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-delete-snapshot": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-destroy": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-dump": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-get-block-info": { "enabled": "0" } })
                user_settings.update({ "libvirtd-domain-get-XML": { "enabled": "0" } })
                user_settings.update({ "libvirtd-domain-managed-save": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-begin3": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-begin3-params": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-confirm3": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-finish2": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-finish3": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-finish3-params": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-perform": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-perform3": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-perform3-params": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-prepare2": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-prepare3": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-prepare3-params": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-prepare3-tunnel": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-prepare-tunnel": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-migrate-prepare-tunnel3": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-nets-restart": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-open-channel": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-open-console": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-open-graphics": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-open-graphics-secret": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-close-graphics": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-close-graphics-secret": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-reboot": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-is-not-responding": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-reset": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-restore": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-resume": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-revert-to-snapshot": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-save": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-save-image": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-save-image-define-XML": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-save-internal": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-save-load": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-screenshot": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-shutdown": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-snapshot-load": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-start": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-start-secret": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-suspend": { "enabled": "1" } })
                user_settings.update({ "libvirtd-undefining-domain": { "enabled": "1" } })
                user_settings.update({ "libvirtd-update-device-config": { "enabled": "1" } })
                user_settings.update({ "libvirtd-config-violation": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-add-object": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-check-error": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-check-fail": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-check-ok": { "enabled": "0" } })
                user_settings.update({ "libvirtd-integrity-event-check-start": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-check-stop": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-create-error": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-delete": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-delete-object": { "enabled": "1" } })
                user_settings.update({ "libvirtd-integrity-event-rewrite": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-define": { "enabled": "1" } })
                user_settings.update({ "libvirtd-system-start": { "enabled": "1" } })    
                user_settings.update({ "libvirtd-system-shutdown": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-block-pull": { "enabled": "1" } })  
                user_settings.update({ "libvirtd-domain-block-commit": { "enabled": "1" } })    
                user_settings.update({ "libvirtd-domain-block-commit-error": { "enabled": "1" } })  
                #memory integrity
                user_settings.update({ "libvirtd-domain-memory-check-add": { "enabled": "1" } })   
                user_settings.update({ "libvirtd-domain-memory-check-calc-begin": { "enabled": "1" } })   
                user_settings.update({ "libvirtd-domain-memory-check-calc-end": { "enabled": "1" } })   
                user_settings.update({ "libvirtd-domain-memory-check-failed": { "enabled": "1" } })   
                user_settings.update({ "libvirtd-domain-memory-check-ok": { "enabled": "0" } })   
                user_settings.update({ "libvirtd-domain-memory-check-request": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-memory-check-control-switch-on": { "enabled": "1" } })  
                user_settings.update({ "libvirtd-domain-memory-check-control-switch-off": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-memory-check-clear-table": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-edit": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-edit-secret": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-edit-acl": { "enabled": "1" } })
                #file integrity
                user_settings.update({ "libvirtd-domain-file-check-error": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-file-check-failed": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-file-check-ok": { "enabled": "0" } })
                user_settings.update({ "libvirtd-domain-file-check-request": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-file-guest-agent-error": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-file-check-error": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-file-check-error-offline-incorrect-checksum": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-file-check-error-offline-missed-files": { "enabled": "1" } })       
                user_settings.update({ "libvirtd-domain-file-check-hash-create": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-file-check-hash-change": { "enabled": "1" } })
                user_settings.update({ "libvirtd-domain-file-check-ok-boot": { "enabled": "1" } })       
                #netport
                user_settings.update({ "libvirtd-domain-net-create-port": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-domain-net-delete-port": { "enabled": "1" } })
                #network
                user_settings.update({ "libvirtd-network-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-define": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-destroy": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-network-port-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-port-delete": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-port-set-parameters": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-shutdown": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-start": { "enabled": "1" } })  
                user_settings.update({ "libvirtd-network-undefine": { "enabled": "1" } })
                user_settings.update({ "libvirtd-network-update": { "enabled": "1" } })
                #storage
                user_settings.update({ "libvirtd-storage-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-define": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-delete": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-destroy": { "enabled": "1" } }) 
                user_settings.update({ "libvirtd-storage-pool-build": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-start": { "enabled": "1" } })  
                user_settings.update({ "libvirtd-storage-undefine": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-out-of-space": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-volume-create": { "enabled": "1" } })
                user_settings.update({ "libvirtd-storage-volume-delete": { "enabled": "1" } })
                try:
                    file.seek(0)
                    json.dump(user_settings, file, indent=4)
                    file.write("\n")
                except Exception as e:
                    print(e)
                    return False
    except Exception as e:
        print(e)
        return False
    return True

def add_syslog_ng_configuration():
    try:
        shutil.copy2("mod-astra-libvirtd.conf", syslog_ng_settings_dir)
        shutil.copy2("mod-astra-libvirtd-remote.conf", syslog_ng_settings_dir)
        shutil.copy2("mod-astra-libvirtd-remote-server.conf", syslog_ng_settings_dir)
    except Exception as e:
        print(e)
        return False
    return True

if __name__ == "__main__":
#    if not add_events_to_default_configuration():
#        exit(-1)
    if not add_events_to_user_configuration():
        exit(-1)
    if not add_syslog_ng_configuration():
        exit(-1)
